character*4 dsaa/'DSAA'/
character*8 ar,re,line
character*1 ps
character*2 lv
real hlev(100)

allocatable v_ini(:,:),vabs_ini(:,:,:)
common/center/fi0,tet0
common/pi/pi,per
common/refmod/nrefmod,hmod(600),vmodp(600),vmods(600)

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0

open(1, file='SET.DAT')
read(1,'(a8)')re	! synthetic model
read(1,'(a8)')ar	! synthetic model
close(1)


!******************************************************************
open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'AREA_CEN') goto 554
end do
553 continue
write(*,*)' cannot find AREA CENTER in MAJOR_PARAM.DAT!!!'
pause
554 read(1,*)fi0,tet0
close(1)

!******************************************************************

! Read the values of the reference model
open(1,file='../../DATA/'//re//'/'//ar//'/ini_param/ref_syn.dat')
read(1,*,end=81)vpvs
i=0
82	i=i+1
	read(1,*,end=81)hmod(i),vmodp(i),vs
	if(vpvs.lt.0.000001) then
		vmods(i)=vs
	else
		vmods(i)=vmodp(i)/vpvs
	end if
	!write(*,*)hmod(i),vmodp(i),vmods(i)
goto 82
81	close(1)
nrefmod=i-1
!write(*,*)' nrefmod=',nrefmod



open(1,file='../../data/'//re//'/'//ar//'/ini_param/anomaly.dat')
read(1,*) n_anomaly
close(1)
write(*,*)' ar=',ar,'   kod of anom.=',n_anomaly


if(n_anomaly.eq.1)then
	call prep_board_dv(re,ar)
else if(n_anomaly.eq.2)then
	call read_hor_an (re,ar)
else if(n_anomaly.eq.3)then
	call read_vert_an(re,ar)
else if(n_anomaly.eq.4)then
	call read_vert_brd(re,ar)
end if

open(2,file='../../data/'//re//'/'//ar//'/ini_param/sethor.dat')
read(2,*) nlev  
read(2,*) (hlev(i),i=1,nlev)  
read(2,*) fmap1,fmap2,dfmap,tmap1,tmap2,dtmap  
close(2)

dfmap=dfmap/4.
dtmap=dtmap/4.

nfmap=int_best((fmap2-fmap1)/dfmap+1.)
ntmap=int_best((tmap2-tmap1)/dtmap+1.)
write(*,*)' nfmap=',nfmap,' ntmap=',ntmap


allocate(v_ini(nfmap,ntmap),vabs_ini(2,nfmap,ntmap))

DO ilev=1,nlev
	zzz=hlev(ilev)
	!zzz=5
	write(lv,'(i2)')ilev
	write(*,*)' ilev=',ilev,' zzz=',zzz
	vabs_ini=0
	do ips=1,2
		write(ps,'(i1)')ips
		dvan=0
		vvv=0
		v0=vrefmod(zzz,ips)


		v_ini=0

		do itet=1,ntmap
			ttt=(itet-1)*dtmap+tmap1+tet0
			!write(*,*)' itet=',itet,' ttt=',ttt
			!ttt=-7.35
			do ifi=1,nfmap
				fff=(ifi-1)*dfmap+fmap1+fi0
				!fff=fi0+1
				!fff=-18.8
				!fff=110.84
				call SFDEC(fff,ttt,0.,xxx,yyy,Z,fi0,tet0)
				if(n_anomaly.eq.1)then
					dv = dv_board(xxx,yyy,zzz,ips)
				else if(n_anomaly.eq.2)then
					dv = hor_anom(xxx,yyy,zzz,ips)
				else if(n_anomaly.eq.3)then
					dv=vert_anom(xxx,yyy,zzz,ips)
				else if(n_anomaly.eq.4)then
					dv=vert_brd(xxx,yyy,zzz,ips)
				end if
				v_ini(ifi,itet)=dv
				vabs_ini(ips,ifi,itet)=v0*(1+dv/100)
				!write(*,*)' fi=',fff,' tet=',ttt,' dv=',dv
				!write(*,*)' x=',xxx,' y=',yyy,' z=',zzz,' dv=',dv
				!pause
			end do
		end do

		open(14,file='../../FIG_files/hor/dv'//ps//'_'//lv//'.grd')
		!open(14,file='../../FIG_files/syn_ini/hor_'//lv//'.grd')
		write(14,'(a4)')dsaa
		write(14,*)nfmap,ntmap
		write(14,*)fmap1+fi0,fmap2+fi0
		write(14,*)tmap1+tet0,tmap2+tet0
		write(14,*)-999,999
		do itet=1,ntmap
			write(14,*)(v_ini(ifi,itet),ifi=1,nfmap)
		end do
		close(14)
	end do
	do itet=1,ntmap
		do ifi=1,nfmap
			v_ini(ifi,itet)=vabs_ini(1,ifi,itet)/vabs_ini(2,ifi,itet)
		end do
	end do
	open(14,file='../../FIG_files/hor/vpvs_'//lv//'.grd')
	write(14,'(a4)')dsaa
	write(14,*)nfmap,ntmap
	write(14,*)fmap1+fi0,fmap2+fi0
	write(14,*)tmap1+tet0,tmap2+tet0
	write(14,*)-999,999
	do itet=1,ntmap
		write(14,*)(v_ini(ifi,itet),ifi=1,nfmap)
	end do
	close(14)
end do

stop
end